#include <stdio.h>
#include "portable_fgets.h"

/* this is copied and modified from K&R p. 165 */

char *zap_fgets (char *s, int n, FILE *fp)
{
	register int c;
	register char *cs;

	cs = s;
	while (--n > 0 && (c = getc (fp)) != EOF) {
		if (c == '\r') c = '\n';  /* change Mac to Unix */
		if (c == '\n') {
			if (cs == s) {
				continue;
			} else {
				break;
			}
		}
		*cs++ = c;
	}

	*cs = '\0';
	return (c == EOF && cs == s) ? NULL : s;
}
